;****************************************************************************
; MODULO PARA MODO DE VIDEO 19
;
; PRUEBA 2 - Salva el viejo modo de video y lo restaura.
;****************************************************************************

;****************************************************************************
; Define los valores.
;****************************************************************************

  PUBLIC MMV19_INICIA_MODO
  PUBLIC MMV19_FINALIZA_MODO

  INTERRUPCION_VIDEO = 10H
  FUNCION_PONE_MODO  = 00H
  MODO               = 19

  SEGMENTO_BIOS = 0040H
  CAMPO_MODO    = 0049H

CAMINO SEGMENT PUBLIC
  ASSUME CS:CAMINO,DS:CAMINO,SS:CAMINO,ES:CAMINO

;****************************************************************************
; Guarda el modo de video y pone el 19. Este modo tiene un rea de 320 * 200,
; y 256 colores.
;
; Escribe:
;   VIEJO_MODO
;****************************************************************************

  LABEL MMV19_INICIA_MODO NEAR

  INICIA_MODO PROC NEAR
    PUSH BX
    PUSH ES
    PUSH AX

;****************************************************************************
; Obtiene el modo de video. Este valor se almacena en el segmento de datos
; del BIOS.
    MOV BX,SEGMENTO_BIOS
    MOV ES,BX
    MOV BX,CAMPO_MODO
    MOV AL,ES:[BX]

;****************************************************************************
; Almacena su valor.
    MOV VIEJO_MODO,AL

;****************************************************************************
; Cambia al nuevo modo.
    MOV AH,FUNCION_PONE_MODO
    MOV AL,MODO
    INT INTERRUPCION_VIDEO

    POP AX
    POP ES
    POP BX
    RET
  INICIA_MODO ENDP

;****************************************************************************
; Pone el viejo modo de video.
;
; Lee:
;   VIEJO_MODO
;****************************************************************************

  LABEL MMV19_FINALIZA_MODO NEAR

  FINALIZA_MODO PROC NEAR
    PUSH AX

;****************************************************************************
; Cambia la viejo modo.
    MOV AH,FUNCION_PONE_MODO
    MOV AL,VIEJO_MODO
    INT INTERRUPCION_VIDEO

    POP AX
    RET
  FINALIZA_MODO ENDP

;****************************************************************************
; Almacena los valores.
;****************************************************************************

  VIEJO_MODO DB 0

CAMINO ENDS

END